/*
 * input.c
 * Source file contains functions regarding reveiving inputs
 */

#include "pos.h"

/*
 * get_cashier_input()
 * Receives input from cashier via touch-screen
 * (Terminal console will replace touch screen)
 * 
 * Parameter(s): void
 * Return type: INPUT(Integer code representing action)
 */
INPUT get_cashier_input()
{
    int input;
    if (fscanf(stdin, "%d", &input) != 1)
    {
        perror("ERROR: Failed to receive Input");
        return ERROR;
    }
    if (input < 1 || input > 7)
    {
        fputs("ERROR: Invalid Input \n", stderr);
        return ERROR;
    }
    return input;
}
/*
 * get_barcode_product_input()
 * Receives input from barcode scanner - limited for product
 * (Terminal console will replace barcode scanner)
 * 
 * Parameter(s): void
 * Return type: Integer - barcode number
 */
char *get_barcode_procduct_input()
{
    char *barcode = (char *)malloc(4);
    memset(barcode, 0, 4);
    printf("상품 번호 : ");
    if (fscanf(stdin, "%s", barcode) != 1)
    {
        perror("ERROR: Failed to receive Input");
        return NULL;
    }
    return barcode;
}
/*
 * get_barcode_receipt_input()
 * Receives input from barcode scanner - limited for receipt
 * (Terminal console will replace barcode scanner)
 * 
 * Parameter(s): void
 * Return type: String - receipt name
 */
char *get_barcode_receipt_input()
{
    char *receipt_name = (char *)malloc(50);
    printf("영주승 번호 : ");
    if (fscanf(stdin, "%s", receipt_name) != 1)
    {
        perror("ERROR: Failed to receive Input");
        return NULL;
    }
    return receipt_name;
}