#ifndef INVEN_HEADER
#define INVEN_HEADER

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "pos.h"

typedef struct _INVEN_NODE
{
    struct _INVEN_NODE *prev;
    struct _INVEN_NODE *next;
    PRODUCT *product;
} INVEN_NODE;

typedef struct _INVEN_LIST
{
    struct _INVEN_NODE *head;
    struct _INVEN_NODE *tail;
} INVEN_LIST;


INVEN_LIST *synchronize();
void update_stock(INVEN_LIST *list);
int add_inventory_node(INVEN_LIST *list, PRODUCT *product);
INVEN_NODE *find_inventory_node(INVEN_LIST *list, char *product_name);
unsigned int get_product_amount(INVEN_LIST *list, char *product_name);
int display_inventory(INVEN_LIST *list);
int print_stock(INVEN_LIST *list);

#endif