/*
 * main.c
 * Main controller for POST
 */

#include "pos.h"
#include "control.h"
#include "daily.h"
#include "display.h"
#include "input.h"
#include "inven.h"
#include "refund.h"
#include "sell.h"

/*
 * main()
 * Main function, literally.
 * Acts like main controller of the system.
 */
int main(int argc, char **argv)
{
    INPUT input;
    FILE *fp;
    int thread_flag;
    int status = 1;


    /* retrieve recent time */
    fp = fopen("current_time.txt", "r");
    if(fp == NULL)
    {
        fp = fopen("current_time.txt", "w");
        /* TODO retrieve current unix time and store */
        fclose(fp);
    }
    else
    {
        char filename[30];
        char buffer[10];

        /* year */
        fscanf(fp, "%s", buffer);
        strcpy(CURRENT_TIME.year, buffer);
        memset(buffer, 0, 10);
        
        /* month */
        fscanf(fp, "%s", buffer);
        strcpy(CURRENT_TIME.month, buffer);
        memset(buffer, 0, 10);
        
        /* date */
        fscanf(fp, "%s", buffer);
        strcpy(CURRENT_TIME.date, buffer);
        memset(buffer, 0, 10);
        
        /* hour */
        fscanf(fp, "%s", buffer);
        strcpy(CURRENT_TIME.hour, buffer);
        memset(buffer, 0, 10);
        
        /* minute */
        fscanf(fp, "%s", buffer);
        strcpy(CURRENT_TIME.minute, buffer);

        fclose(fp);

        strcpy(filename, get_current_date());
        strcat(filename, "_product.txt");

        fp = fopen(filename, "r");
        if (fp == NULL)
        {
            renew_server();
        }
        fclose(fp);
    }

    /* Create thread for time */
    thread_flag = pthread_create(&time_thr, NULL, time_function, (void *)&status);

    while (1)
    {
        system("clear");
        display_main_menu();
        input = get_cashier_input();

        if (input == TURN_OFF)
        {
            status = 0;
            pthread_join(time_thr, NULL);
            /* TODO Save time */
            fp = fopen("current_time.txt", "w");
            fprintf(fp, "%s\n", CURRENT_TIME.year);
            fprintf(fp, "%s\n", CURRENT_TIME.month);
            fprintf(fp, "%s\n", CURRENT_TIME.date);
            fprintf(fp, "%s\n", CURRENT_TIME.hour);
            fprintf(fp, "%s\n", CURRENT_TIME.minute);
            fclose(fp);

            return 0;
        }
        else if (input == SELL)
        {
            // TODO Thread lock
            sell();
        }
        else if (input == REFUND)
        {
            // TODO Thread lock
            refund();
        }
        else if (input == CHECK_STOCK)
        {
            // TODO Thread lock
            check_stock();
        }
        else
        {
            fputs("ERROR : Invalid Input \n", stderr);
        }

        if (status == 2)
        {
            print_daily_report();
        }

        sleep(1);
    }

    return 0;
}
