/*
 * sell.h
 * Header file for functions about sell procedure
 */

#ifndef SELL_HEADER
#define SELL_HEADER

/* Header file(s) to include */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "pos.h"
#include "inven.h"

/* Constants */
#define QUANTITY_PLUS 1
#define QUANTITY_MINUS 2
#define BARCODE_SELL 3
#define RECEIPT_SELL 4

/* Data types */
typedef struct _SELL_NODE
{
    struct _SELL_NODE *prev;
    struct _SELL_NODE *next;
    char product_name[20];
    unsigned int product_quantity;
    unsigned int product_price;
} SELL_NODE;

typedef struct _SELL_LIST
{
    SELL_NODE *head;
    SELL_NODE *tail;
    unsigned int total_price;
} SELL_LIST;

/* Functions */
SELL_LIST *sell_init();
int is_sell_list_empty(SELL_LIST *list);
int add_sell_node(SELL_LIST *list, PRODUCT *product);
SELL_NODE *find_node(SELL_LIST *list, char *product_name);
PRODUCT *get_product_barcode(char *barcode_num);
int product_quantity_minus(SELL_LIST *list, SELL_NODE *node, INVEN_NODE *inven);
int product_quantity_plus(SELL_LIST *list, SELL_NODE *node, INVEN_NODE *inven);
void perform_purchase(SELL_LIST *list);
int print_sell_receipt(SELL_LIST *list);
void add_sale_management(SELL_LIST *list);
void display_cashier_screen(SELL_LIST *list, int price_input);
void display_customer_screen(int total_price, int price_input);

#endif